%global major 1
%define libqrcodegen %mklibname qrcodegen %{major}
%define libqrcodegendev %mklibname -d qrcodegen
%define libqrcodegencpp %mklibname qrcodegencpp %{major}
%define libqrcodegencppdev %mklibname -d qrcodegencpp
%global richname QR-Code-generator
%global cmakename qrcodegen-cmake
%global cmakesuffix cmake1

Name: qr-code-generator
Version: 1.8.0
Release: %mkrel 1

License: MIT
Summary: High-quality QR Code generator library
Group:   System/Libraries
URL: https://github.com/nayuki/%{richname}
Source0: https://github.com/nayuki/%{richname}/archive/v%{version}/%{name}-%{version}.tar.gz
Source1: https://github.com/EasyCoding/%{cmakename}/archive/v%{version}-%{cmakesuffix}/%{cmakename}-%{version}-%{cmakesuffix}.tar.gz

BuildRequires: cmake
BuildRequires: gcc
BuildRequires: gcc-c++
BuildRequires: ninja
BuildRequires: python3-devel
BuildRequires: python3-setuptools

%description
This project aims to be the best, clearest QR Code generator library in
multiple languages.

The primary goals are flexible options and absolute correctness.
Secondary goals are compact implementation size and good documentation
comments.

%package -n %{libqrcodegen}
Summary: High-quality QR Code generator library (plain C version)
Obsoletes: %{_lib}rcodegen1 < 1.5.0-3

%description -n %{libqrcodegen}
This project aims to be the best, clearest QR Code generator library in
multiple languages.

The primary goals are flexible options and absolute correctness.
Secondary goals are compact implementation size and good documentation
comments.

%package -n %{libqrcodegendev}
Summary: Development files for libqrcodegen
Requires: %{libqrcodegen} = %{?epoch:%{epoch}:}%{version}-%{release}
Provides: libqrcodegen-devel = %{version}-%{release}

%description -n %{libqrcodegendev}
Development files and headers for high-quality QR Code generator library
(plain C version).

%package -n %{libqrcodegencpp}
Summary: High-quality QR Code generator library (C++ version)
Obsoletes: %{_lib}rcodegencpp1 < 1.5.0-2

%description -n %{libqrcodegencpp}
This project aims to be the best, clearest QR Code generator library in
multiple languages.

The primary goals are flexible options and absolute correctness.
Secondary goals are compact implementation size and good documentation
comments.

%package -n %{libqrcodegencppdev}
Summary: Development files for libqrcodegencpp
Requires: %{libqrcodegencpp} = %{?epoch:%{epoch}:}%{version}-%{release}
Provides: libqrcodegencpp-devel = %{version}-%{release}

%description -n %{libqrcodegencppdev}
Development files and headers for high-quality QR Code generator library
(C++ version).

%package -n python3-qrcodegen
Summary: High-quality QR Code generator library (Python version)
BuildArch: noarch
%{?python_provide:%python_provide python3-qrcodegen}

%description -n python3-qrcodegen
This project aims to be the best, clearest QR Code generator library in
multiple languages.

The primary goals are flexible options and absolute correctness.
Secondary goals are compact implementation size and good documentation
comments.

%prep
%autosetup -n %{richname}-%{version} -p1

# Unpacking CMake build script and assets...
tar -xf %{SOURCE1} %{cmakename}-%{version}-%{cmakesuffix}/cmake %{cmakename}-%{version}-%{cmakesuffix}/CMakeLists.txt --strip=1

%build
# Building C and C++ versions...
%cmake -G Ninja \
    -DCMAKE_BUILD_TYPE=Release \
    -DBUILD_TESTS:BOOL=ON
%cmake_build

# Building Python version...
pushd python
%py3_build
popd

%check
%ctest

%install
# Installing C and C++ versions...
%cmake_install

# Installing Python version...
pushd python
%py3_install
popd

# Installing a legacy symlink for compatibility...
ln -s qrcodegen.hpp %{buildroot}%{_includedir}/qrcodegencpp/QrCode.hpp

%files -n %{libqrcodegen}
%license Readme.markdown
%{_libdir}/libqrcodegen.so.%{major}{,.*}

%files -n %{libqrcodegendev}
%{_includedir}/qrcodegen/
%{_libdir}/cmake/qrcodegen/
%{_libdir}/libqrcodegen.so
%{_libdir}/pkgconfig/qrcodegen.pc

%files -n %{libqrcodegencpp}
%license Readme.markdown
%{_libdir}/libqrcodegencpp.so.%{major}{,.*}

%files -n %{libqrcodegencppdev}
%{_includedir}/qrcodegencpp/
%{_libdir}/cmake/qrcodegencpp/
%{_libdir}/libqrcodegencpp.so
%{_libdir}/pkgconfig/qrcodegencpp.pc

%files -n python3-qrcodegen
%license Readme.markdown
%{python3_sitelib}/qrcodegen.py
%{python3_sitelib}/__pycache__/*
%{python3_sitelib}/qrcodegen-*.egg-info/



%changelog
* Mon Apr 25 2022 tv <tv> 1.8.0-1.mga9
+ Revision: 1853177
- Updated to version 1.8.0.

* Tue Mar 29 2022 umeabot <umeabot> 1.7.0-4.mga9
+ Revision: 1833265
- Mageia 9 Mass Rebuild

* Thu Feb 17 2022 tv <tv> 1.7.0-3.mga9
+ Revision: 1778541
- Rebuild for python-3.10

* Mon Oct 18 2021 tv <tv> 1.7.0-2.mga9
+ Revision: 1752035
- Enabled pkgconfig and CMake configs support.
- Enabled unit tests.
- Added a legacy symlink for compatibility.

* Mon Aug 16 2021 luigiwalser <luigiwalser> 1.7.0-1.mga9
+ Revision: 1741666
- 1.7.0
- switch to cmake build system (resync with fedora)

* Mon Apr 19 2021 daviddavid <daviddavid> 1.6.0-2.mga9
+ Revision: 1716974
- rebuild for python 3.9

* Tue Jul 21 2020 tv <tv> 1.6.0-1.mga8
+ Revision: 1607684
- Updated to version 1.6.0.

* Thu Feb 20 2020 umeabot <umeabot> 1.5.0-6.mga8
+ Revision: 1546293
- Mageia 8 Mass Rebuild

* Sat Feb 01 2020 wally <wally> 1.5.0-5.mga8
+ Revision: 1486307
- obsolete wrongly named libs

* Thu Jan 30 2020 tv <tv> 1.5.0-4.mga8
+ Revision: 1485428
- move provides where it belongs

* Thu Jan 30 2020 tv <tv> 1.5.0-3.mga8
+ Revision: 1485395
- fix lib names

* Thu Jan 30 2020 tv <tv> 1.5.0-2.mga8
+ Revision: 1485365
- add provides to devel pkgs
- fix lib names

* Thu Jan 30 2020 tv <tv> 1.5.0-1.mga8
+ Revision: 1485320
- imported package qr-code-generator

